diff --git a/compiler/utils/Digraph.lhs b/compiler/utils/Digraph.lhs
index cc68430..a834f1b 100644
--- a/compiler/utils/Digraph.lhs
+++ b/compiler/utils/Digraph.lhs
@@ -3,12 +3,6 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 {-# LANGUAGE ScopedTypeVariables #-}
 module Digraph(
@@ -78,10 +72,10 @@ Note [Nodes, keys, vertices]
  * A 'node' is a big blob of client-stuff
 
  * Each 'node' has a unique (client) 'key', but the latter 
-	is in Ord and has fast comparison
+        is in Ord and has fast comparison
 
  * Digraph then maps each 'key' to a Vertex (Int) which is
-  	arranged densely in 0.n
+        arranged densely in 0.n
 
 \begin{code}
 data Graph node = Graph { 
@@ -92,12 +86,12 @@ data Graph node = Graph {
 
 data Edge node = Edge node node
 
-type Node key payload = (payload, key, [key])	
+type Node key payload = (payload, key, [key])   
      -- The payload is user data, just carried around in this module
      -- The keys are ordered
      -- The [key] are the dependencies of the node; 
      --    it's ok to have extra keys in the dependencies that
-     --	   are not the key of any Node in the graph
+     --    are not the key of any Node in the graph
 
 emptyGraph :: Graph a
 emptyGraph = Graph (array (1, 0) []) (error "emptyGraph") (const Nothing)
@@ -168,18 +162,18 @@ reduceNodesIntoVertices nodes key_extractor = (bounds, (!) vertex_map, key_verte
 
 \begin{code}
 type WorkItem key payload
-  = (Node key payload,	-- Tip of the path
-     [payload])	  	-- Rest of the path; 
-     			--  [a,b,c] means c depends on b, b depends on a
+  = (Node key payload,  -- Tip of the path
+     [payload])         -- Rest of the path; 
+                        --  [a,b,c] means c depends on b, b depends on a
 
 -- | Find a reasonably short cycle a->b->c->a, in a strongly
 -- connected component.  The input nodes are presumed to be
 -- a SCC, so you can start anywhere.
 findCycle :: forall payload key. Ord key 
           => [Node key payload]     -- The nodes.  The dependencies can
-	     	     	  	    -- contain extra keys, which are ignored
-	  -> Maybe [payload]        -- A cycle, starting with node
-	     			    -- so each depends on the next
+                                    -- contain extra keys, which are ignored
+          -> Maybe [payload]        -- A cycle, starting with node
+                                    -- so each depends on the next
 findCycle graph
   = go Set.empty (new_work root_deps []) []
   where
@@ -195,14 +189,14 @@ findCycle graph
 
 
     -- 'go' implements Dijkstra's algorithm, more or less
-    go :: Set.Set key	-- Visited
-       -> [WorkItem key payload]	-- Work list, items length n
-       -> [WorkItem key payload]	-- Work list, items length n+1
-       -> Maybe [payload]		-- Returned cycle
+    go :: Set.Set key   -- Visited
+       -> [WorkItem key payload]        -- Work list, items length n
+       -> [WorkItem key payload]        -- Work list, items length n+1
+       -> Maybe [payload]               -- Returned cycle
        -- Invariant: in a call (go visited ps qs),
        --            visited = union (map tail (ps ++ qs))
 
-    go _       [] [] = Nothing	-- No cycles
+    go _       [] [] = Nothing  -- No cycles
     go visited [] qs = go visited qs []
     go visited (((payload,key,deps), path) : ps) qs 
        | key == root_key           = Just (root_payload : reverse path)
@@ -211,7 +205,7 @@ findCycle graph
        | otherwise                 = go (Set.insert key visited)
                                         ps (new_qs ++ qs)
        where
-	 new_qs = new_work deps (payload : path)
+         new_qs = new_work deps (payload : path)
 
     new_work :: [key] -> [payload] -> [WorkItem key payload]
     new_work deps path = [ (n, path) | Just n <- map (`Map.lookup` env) deps ]
diff --git a/compiler/utils/GraphBase.hs b/compiler/utils/GraphBase.hs
index 8cb3ace..de506e3 100644
--- a/compiler/utils/GraphBase.hs
+++ b/compiler/utils/GraphBase.hs
@@ -1,22 +1,16 @@
 
 -- | Types for the general graph colorer.
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module GraphBase (
-	Triv,
-	Graph (..),
-	initGraph,
-	graphMapModify,
+        Triv,
+        Graph (..),
+        initGraph,
+        graphMapModify,
 
-	Node  (..),	newNode,
+        Node  (..),     newNode,
 )
-	
+        
 
 where
 
@@ -25,92 +19,92 @@ import UniqFM
 
 
 -- | A fn to check if a node is trivially colorable
---	For graphs who's color classes are disjoint then a node is 'trivially colorable'
---	when it has less neighbors and exclusions than available colors for that node.
+--      For graphs who's color classes are disjoint then a node is 'trivially colorable'
+--      when it has less neighbors and exclusions than available colors for that node.
 --
---	For graph's who's color classes overlap, ie some colors alias other colors, then
---	this can be a bit more tricky. There is a general way to calculate this, but 
---	it's likely be too slow for use in the code. The coloring algorithm takes
---	a canned function which can be optimised by the user to be specific to the 
---	specific graph being colored.
+--      For graph's who's color classes overlap, ie some colors alias other colors, then
+--      this can be a bit more tricky. There is a general way to calculate this, but 
+--      it's likely be too slow for use in the code. The coloring algorithm takes
+--      a canned function which can be optimised by the user to be specific to the 
+--      specific graph being colored.
 --
---	for details, see  "A Generalised Algorithm for Graph-Coloring Register Allocation"
---				Smith, Ramsey, Holloway - PLDI 2004.
+--      for details, see  "A Generalised Algorithm for Graph-Coloring Register Allocation"
+--                              Smith, Ramsey, Holloway - PLDI 2004.
 --
 type Triv k cls color
-	=  cls 			-- the class of the node we're trying to color.
-	-> UniqSet k		-- the node's neighbors.
-	-> UniqSet color 	-- the node's exclusions.
-	-> Bool		
+        =  cls                  -- the class of the node we're trying to color.
+        -> UniqSet k            -- the node's neighbors.
+        -> UniqSet color        -- the node's exclusions.
+        -> Bool         
 
 
 -- | The Interference graph.
---	There used to be more fields, but they were turfed out in a previous revision.
---	maybe we'll want more later..
+--      There used to be more fields, but they were turfed out in a previous revision.
+--      maybe we'll want more later..
 --
 data Graph k cls color
-	= Graph { 
-	-- | All active nodes in the graph.
-	  graphMap		:: UniqFM (Node k cls color)  }
+        = Graph { 
+        -- | All active nodes in the graph.
+          graphMap              :: UniqFM (Node k cls color)  }
 
 
--- | An empty graph.	
+-- | An empty graph.    
 initGraph :: Graph k cls color
 initGraph
-	= Graph
-	{ graphMap		= emptyUFM }
+        = Graph
+        { graphMap              = emptyUFM }
 
 
 -- | Modify the finite map holding the nodes in the graph.
 graphMapModify 
-	:: (UniqFM (Node k cls color) -> UniqFM (Node k cls color))
-	-> Graph k cls color -> Graph k cls color
+        :: (UniqFM (Node k cls color) -> UniqFM (Node k cls color))
+        -> Graph k cls color -> Graph k cls color
 
 graphMapModify f graph
-	= graph { graphMap	= f (graphMap graph) }
-	
-		
+        = graph { graphMap      = f (graphMap graph) }
+        
+                
 
 -- | Graph nodes.
---	Represents a thing that can conflict with another thing.
---	For the register allocater the nodes represent registers.
+--      Represents a thing that can conflict with another thing.
+--      For the register allocater the nodes represent registers.
 --
 data Node k cls color
-	= Node { 	
-	-- | A unique identifier for this node.
-	  nodeId 		:: k
+        = Node {        
+        -- | A unique identifier for this node.
+          nodeId                :: k
 
-	-- | The class of this node,
-	--	determines the set of colors that can be used.
-	, nodeClass		:: cls
+        -- | The class of this node,
+        --      determines the set of colors that can be used.
+        , nodeClass             :: cls
 
-	-- | The color of this node, if any.
-	, nodeColor		:: Maybe color
+        -- | The color of this node, if any.
+        , nodeColor             :: Maybe color
 
-	-- | Neighbors which must be colored differently to this node.
-	, nodeConflicts		:: UniqSet k
+        -- | Neighbors which must be colored differently to this node.
+        , nodeConflicts         :: UniqSet k
 
-	-- | Colors that cannot be used by this node.
-	, nodeExclusions	:: UniqSet color
+        -- | Colors that cannot be used by this node.
+        , nodeExclusions        :: UniqSet color
 
-	-- | Colors that this node would prefer to be, in decending order.
-	, nodePreference	:: [color]  
+        -- | Colors that this node would prefer to be, in decending order.
+        , nodePreference        :: [color]  
 
-	-- | Neighbors that this node would like to be colored the same as.
-	, nodeCoalesce		:: UniqSet k }
+        -- | Neighbors that this node would like to be colored the same as.
+        , nodeCoalesce          :: UniqSet k }
 
 
 -- | An empty node.
 newNode :: k -> cls -> Node k cls color
 newNode k cls
-	= Node
-	{ nodeId		= k
-	, nodeClass		= cls
-	, nodeColor		= Nothing
-	, nodeConflicts		= emptyUniqSet
-	, nodeExclusions	= emptyUniqSet
-	, nodePreference	= [] 
-	, nodeCoalesce		= emptyUniqSet }
+        = Node
+        { nodeId                = k
+        , nodeClass             = cls
+        , nodeColor             = Nothing
+        , nodeConflicts         = emptyUniqSet
+        , nodeExclusions        = emptyUniqSet
+        , nodePreference        = [] 
+        , nodeCoalesce          = emptyUniqSet }
 
 
 
diff --git a/compiler/utils/GraphPpr.hs b/compiler/utils/GraphPpr.hs
index a896bbb..1ffbd39 100644
--- a/compiler/utils/GraphPpr.hs
+++ b/compiler/utils/GraphPpr.hs
@@ -1,16 +1,10 @@
 
 -- | Pretty printing of graphs.
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module GraphPpr (
-	dumpGraph,
-	dotGraph
+        dumpGraph,
+        dotGraph
 )
 where
 
@@ -27,150 +21,150 @@ import Data.Maybe
 
 -- | Pretty print a graph in a somewhat human readable format.
 dumpGraph 
-	:: (Outputable k, Outputable cls, Outputable color)
-	=> Graph k cls color -> SDoc
+        :: (Outputable k, Outputable cls, Outputable color)
+        => Graph k cls color -> SDoc
 
 dumpGraph graph
-	=  text "Graph"
-	$$ (vcat $ map dumpNode $ eltsUFM $ graphMap graph)
-	
+        =  text "Graph"
+        $$ (vcat $ map dumpNode $ eltsUFM $ graphMap graph)
+        
 dumpNode 
-	:: (Outputable k, Outputable cls, Outputable color)
-	=> Node k cls color -> SDoc
+        :: (Outputable k, Outputable cls, Outputable color)
+        => Node k cls color -> SDoc
 
 dumpNode node
- 	=  text "Node " <> ppr (nodeId node)
-	$$ text "conflicts " 
-		<> parens (int (sizeUniqSet $ nodeConflicts node)) 
-		<> text " = "
-		<> ppr (nodeConflicts node) 
+        =  text "Node " <> ppr (nodeId node)
+        $$ text "conflicts " 
+                <> parens (int (sizeUniqSet $ nodeConflicts node)) 
+                <> text " = "
+                <> ppr (nodeConflicts node) 
 
-	$$ text "exclusions "
-		<> parens (int (sizeUniqSet $ nodeExclusions node))
-		<> text " = " 
-		<> ppr (nodeExclusions node)
+        $$ text "exclusions "
+                <> parens (int (sizeUniqSet $ nodeExclusions node))
+                <> text " = " 
+                <> ppr (nodeExclusions node)
 
-	$$ text "coalesce "
-		<> parens (int (sizeUniqSet $ nodeCoalesce node))
-		<> text " = "
-		<> ppr (nodeCoalesce node)
-		
-	$$ space
+        $$ text "coalesce "
+                <> parens (int (sizeUniqSet $ nodeCoalesce node))
+                <> text " = "
+                <> ppr (nodeCoalesce node)
+                
+        $$ space
 
 
 
 -- | Pretty print a graph in graphviz .dot format.
---	Conflicts get solid edges.
---	Coalescences get dashed edges.
+--      Conflicts get solid edges.
+--      Coalescences get dashed edges.
 dotGraph 
-	:: ( Uniquable k
-	   , Outputable k, Outputable cls, Outputable color)
-	=> (color -> SDoc)  -- ^ What graphviz color to use for each node color
-			    --	It's usually safe to return X11 style colors here,
-			    --	ie "red", "green" etc or a hex triplet #aaff55 etc
-	-> Triv k cls color
-	-> Graph k cls color -> SDoc
+        :: ( Uniquable k
+           , Outputable k, Outputable cls, Outputable color)
+        => (color -> SDoc)  -- ^ What graphviz color to use for each node color
+                            --  It's usually safe to return X11 style colors here,
+                            --  ie "red", "green" etc or a hex triplet #aaff55 etc
+        -> Triv k cls color
+        -> Graph k cls color -> SDoc
 
 dotGraph colorMap triv graph
- = let	nodes	= eltsUFM $ graphMap graph
-   in	vcat 
-		(  [ text "graph G {" ]
-		++ map (dotNode colorMap triv) nodes
-		++ (catMaybes $ snd $ mapAccumL dotNodeEdges emptyUniqSet nodes)
-		++ [ text "}"
-		   , space ])
-	
+ = let  nodes   = eltsUFM $ graphMap graph
+   in   vcat 
+                (  [ text "graph G {" ]
+                ++ map (dotNode colorMap triv) nodes
+                ++ (catMaybes $ snd $ mapAccumL dotNodeEdges emptyUniqSet nodes)
+                ++ [ text "}"
+                   , space ])
+        
 
 dotNode :: ( Uniquable k
-	   , Outputable k, Outputable cls, Outputable color)
-	=> (color -> SDoc)
-	-> Triv k cls color
-	-> Node k cls color -> SDoc
-	
+           , Outputable k, Outputable cls, Outputable color)
+        => (color -> SDoc)
+        -> Triv k cls color
+        -> Node k cls color -> SDoc
+        
 dotNode colorMap triv node
- = let	name	= ppr $ nodeId node
-	cls	= ppr $ nodeClass node
-
-	excludes
-		= hcat $ punctuate space 
-		$ map (\n -> text "-" <> ppr n)
-		$ uniqSetToList $ nodeExclusions node
-		
-	preferences
-		= hcat $ punctuate space
-		$ map (\n -> text "+" <> ppr n)
-		$ nodePreference node
-	
-	expref	= if and [isEmptyUniqSet (nodeExclusions node), null (nodePreference node)]
-			then empty
-			else text "\\n" <> (excludes <+> preferences)
-
-	-- if the node has been colored then show that,
-	--	otherwise indicate whether it looks trivially colorable.
-	color
-		| Just c	<- nodeColor node 
-		= text "\\n(" <> ppr c <> text ")"
-
-		| triv (nodeClass node) (nodeConflicts node) (nodeExclusions node)
-		= text "\\n(" <> text "triv" <> text ")"
-
-		| otherwise
-		= text "\\n(" <> text "spill?" <> text ")"
-
-	label	=  name <> text " :: " <> cls
-		<> expref
-		<> color
-
-	pcolorC	= case nodeColor node of
-			Nothing	-> text "style=filled fillcolor=white"
-			Just c	-> text "style=filled fillcolor=" <> doubleQuotes (colorMap c)
-		
-
-	pout	= text "node [label=" <> doubleQuotes label <> space <> pcolorC <> text "]" 
-		<> space <> doubleQuotes name 
-		<> text ";"
-
- in	pout
+ = let  name    = ppr $ nodeId node
+        cls     = ppr $ nodeClass node
+
+        excludes
+                = hcat $ punctuate space 
+                $ map (\n -> text "-" <> ppr n)
+                $ uniqSetToList $ nodeExclusions node
+                
+        preferences
+                = hcat $ punctuate space
+                $ map (\n -> text "+" <> ppr n)
+                $ nodePreference node
+        
+        expref  = if and [isEmptyUniqSet (nodeExclusions node), null (nodePreference node)]
+                        then empty
+                        else text "\\n" <> (excludes <+> preferences)
+
+        -- if the node has been colored then show that,
+        --      otherwise indicate whether it looks trivially colorable.
+        color
+                | Just c        <- nodeColor node 
+                = text "\\n(" <> ppr c <> text ")"
+
+                | triv (nodeClass node) (nodeConflicts node) (nodeExclusions node)
+                = text "\\n(" <> text "triv" <> text ")"
+
+                | otherwise
+                = text "\\n(" <> text "spill?" <> text ")"
+
+        label   =  name <> text " :: " <> cls
+                <> expref
+                <> color
+
+        pcolorC = case nodeColor node of
+                        Nothing -> text "style=filled fillcolor=white"
+                        Just c  -> text "style=filled fillcolor=" <> doubleQuotes (colorMap c)
+                
+
+        pout    = text "node [label=" <> doubleQuotes label <> space <> pcolorC <> text "]" 
+                <> space <> doubleQuotes name 
+                <> text ";"
+
+ in     pout
 
 
 -- | Nodes in the graph are doubly linked, but we only want one edge for each
---	conflict if the graphviz graph. Traverse over the graph, but make sure
---	to only print the edges for each node once.
+--      conflict if the graphviz graph. Traverse over the graph, but make sure
+--      to only print the edges for each node once.
 
 dotNodeEdges 
-	:: ( Uniquable k
-	   , Outputable k, Outputable cls, Outputable color)
-	=> UniqSet k
-	-> Node k cls color
-	-> (UniqSet k, Maybe SDoc)
+        :: ( Uniquable k
+           , Outputable k, Outputable cls, Outputable color)
+        => UniqSet k
+        -> Node k cls color
+        -> (UniqSet k, Maybe SDoc)
 
 dotNodeEdges visited node
-	| elementOfUniqSet (nodeId node) visited
-	= ( visited
-	  , Nothing)
-	
-	| otherwise
-	= let	dconflicts
-			= map (dotEdgeConflict (nodeId node)) 
-			$ uniqSetToList
-			$ minusUniqSet (nodeConflicts node) visited
-				
-		dcoalesces
-			= map (dotEdgeCoalesce (nodeId node))
-			$ uniqSetToList
-			$ minusUniqSet (nodeCoalesce node) visited
-	
-		out	=  vcat dconflicts
-			$$ vcat dcoalesces
-
-	  in	( addOneToUniqSet visited (nodeId node)
-		, Just out)
-
-	where	dotEdgeConflict u1 u2
-			= doubleQuotes (ppr u1) <> text " -- " <> doubleQuotes (ppr u2) 
-			<> text ";"
-
-		dotEdgeCoalesce u1 u2
-			= doubleQuotes (ppr u1) <> text " -- " <> doubleQuotes (ppr u2) 
-			<> space <> text "[ style = dashed ];"
+        | elementOfUniqSet (nodeId node) visited
+        = ( visited
+          , Nothing)
+        
+        | otherwise
+        = let   dconflicts
+                        = map (dotEdgeConflict (nodeId node)) 
+                        $ uniqSetToList
+                        $ minusUniqSet (nodeConflicts node) visited
+                                
+                dcoalesces
+                        = map (dotEdgeCoalesce (nodeId node))
+                        $ uniqSetToList
+                        $ minusUniqSet (nodeCoalesce node) visited
+        
+                out     =  vcat dconflicts
+                        $$ vcat dcoalesces
+
+          in    ( addOneToUniqSet visited (nodeId node)
+                , Just out)
+
+        where   dotEdgeConflict u1 u2
+                        = doubleQuotes (ppr u1) <> text " -- " <> doubleQuotes (ppr u2) 
+                        <> text ";"
+
+                dotEdgeCoalesce u1 u2
+                        = doubleQuotes (ppr u1) <> text " -- " <> doubleQuotes (ppr u2) 
+                        <> space <> text "[ style = dashed ];"
 
diff --git a/utils/genprimopcode/Main.hs b/utils/genprimopcode/Main.hs
index 8b97ca1..35e4367 100644
--- a/utils/genprimopcode/Main.hs
+++ b/utils/genprimopcode/Main.hs
@@ -246,7 +246,7 @@ gen_hs_source (Info defaults entries) =
         ++ "-----------------------------------------------------------------------------\n"
         ++ "{-# LANGUAGE MultiParamTypeClasses #-}\n"
         ++ "module GHC.Prim (\n"
-        ++ unlines (map (("\t" ++) . hdr) entries')
+        ++ unlines (map (("        " ++) . hdr) entries')
         ++ ") where\n"
     ++ "\n"
     ++ "{-\n"
@@ -750,7 +750,7 @@ gen_primop_vector_tys_exports (Info _ entries)
 
     mkVecTypes :: Entry -> String
     mkVecTypes i =
-        "\t" ++ ty_id ++ ", " ++ tycon_id ++ ","
+        "        " ++ ty_id ++ ", " ++ tycon_id ++ ","
       where
         ty_id    = prefix i ++ "PrimTy"
         tycon_id = prefix i ++ "PrimTyCon"
-- 
1.8.1.2

